Index: c/src/lib/libbsp/powerpc/qoriq/console/console-config.c
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/console/console-config.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/qoriq/console/console-config.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2010 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2010-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -21,23 +21,14 @@
  */
 
-#include <assert.h>
-
 #include <rtems/bspIo.h>
 
-#include <libchip/serial.h>
 #include <libchip/ns16550.h>
-#include "../../../shared/console_private.h"
 
-#include <bspopts.h>
+#include <bsp.h>
 #include <bsp/irq.h>
 #include <bsp/qoriq.h>
 #include <bsp/intercom.h>
 #include <bsp/uart-bridge.h>
-
-#define CONSOLE_COUNT \
-  (QORIQ_UART_0_ENABLE \
-    + QORIQ_UART_1_ENABLE \
-    + QORIQ_UART_BRIDGE_0_ENABLE \
-    + QORIQ_UART_BRIDGE_1_ENABLE)
+#include <bsp/console-termios.h>
 
 #if (QORIQ_UART_0_ENABLE + QORIQ_UART_BRIDGE_0_ENABLE == 2) \
@@ -48,54 +39,8 @@
 #endif
 
-#ifdef BRIDGE_MASTER
-  #define BRIDGE_FNS &qoriq_uart_bridge_master
-  #if QORIQ_UART_BRIDGE_0_ENABLE
-    static uart_bridge_master_control bridge_0_control = {
-      .device_path = "/dev/ttyS0",
-      .type = INTERCOM_TYPE_UART_0,
-      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
-        bridge_0_control.transmit_fifo
-      )
-    };
-    #define BRIDGE_0_CONTROL &bridge_0_control
-  #endif
-  #if QORIQ_UART_BRIDGE_1_ENABLE
-    static uart_bridge_master_control bridge_1_control = {
-      .device_path = "/dev/ttyS1",
-      .type = INTERCOM_TYPE_UART_1,
-      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
-        bridge_1_control.transmit_fifo
-      )
-    };
-    #define BRIDGE_1_CONTROL &bridge_1_control
-  #endif
-#endif
-
-#ifdef BRIDGE_SLAVE
-  #define BRIDGE_FNS &qoriq_uart_bridge_slave
-  #if QORIQ_UART_BRIDGE_0_ENABLE
-    static uart_bridge_slave_control bridge_0_control = {
-      .type = INTERCOM_TYPE_UART_0,
-      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
-        bridge_0_control.transmit_fifo
-      )
-    };
-    #define BRIDGE_0_CONTROL &bridge_0_control
-  #endif
-  #if QORIQ_UART_BRIDGE_1_ENABLE
-    static uart_bridge_slave_control bridge_1_control = {
-      .type = INTERCOM_TYPE_UART_1,
-      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
-        bridge_1_control.transmit_fifo
-      )
-    };
-    #define BRIDGE_1_CONTROL &bridge_1_control
-  #endif
-#endif
-
 #ifdef BSP_USE_UART_INTERRUPTS
-  #define DEVICE_FNS &ns16550_fns
+  #define DEVICE_FNS &ns16550_handler_interrupt
 #else
-  #define DEVICE_FNS &ns16550_fns_polled
+  #define DEVICE_FNS &ns16550_handler_polled
 #endif
 
@@ -112,50 +57,97 @@
     volatile uint8_t *reg = (uint8_t *) addr;
 
-    reg [i] = val; 
+    reg [i] = val;
   }
 #endif
 
-unsigned long Console_Configuration_Count = CONSOLE_COUNT;
-console_tbl Console_Configuration_Ports [CONSOLE_COUNT] = {
+#if QORIQ_UART_0_ENABLE
+static ns16550_context qoriq_uart_context_0 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 0"),
+  .get_reg = get_register,
+  .set_reg = set_register,
+  .port = (uintptr_t) &qoriq.uart_0,
+  .irq = QORIQ_IRQ_DUART,
+  .initial_baud = BSP_CONSOLE_BAUD
+};
+#endif
+
+#if QORIQ_UART_1_ENABLE
+static ns16550_context qoriq_uart_context_1 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 1"),
+  .get_reg = get_register,
+  .set_reg = set_register,
+  .port = (uintptr_t) &qoriq.uart_1,
+  .irq = QORIQ_IRQ_DUART,
+  .initial_baud = BSP_CONSOLE_BAUD
+};
+#endif
+
+#ifdef BRIDGE_MASTER
+  #define BRIDGE_PROBE qoriq_uart_bridge_master_probe
+  #define BRIDGE_FNS &qoriq_uart_bridge_master
+  #if QORIQ_UART_BRIDGE_0_ENABLE
+    static uart_bridge_master_context bridge_0_context = {
+      .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART Bridge 0"),
+      .device_path = "/dev/ttyS0",
+      .type = INTERCOM_TYPE_UART_0,
+      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
+        bridge_0_context.transmit_fifo
+      )
+    };
+    #define BRIDGE_0_CONTEXT &bridge_0_context
+  #endif
+  #if QORIQ_UART_BRIDGE_1_ENABLE
+    static uart_bridge_master_context bridge_1_context = {
+      .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART Bridge 1"),
+      .device_path = "/dev/ttyS1",
+      .type = INTERCOM_TYPE_UART_1,
+      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
+        bridge_1_context.transmit_fifo
+      )
+    };
+    #define BRIDGE_1_CONTEXT &bridge_1_context
+  #endif
+#endif
+
+#ifdef BRIDGE_SLAVE
+  #define BRIDGE_PROBE console_device_probe_default
+  #define BRIDGE_FNS &qoriq_uart_bridge_slave
+  #if QORIQ_UART_BRIDGE_0_ENABLE
+    static uart_bridge_slave_context bridge_0_context = {
+      .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART Bridge 0"),
+      .type = INTERCOM_TYPE_UART_0,
+      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
+        bridge_0_context.transmit_fifo
+      )
+    };
+    #define BRIDGE_0_CONTEXT &bridge_0_context
+  #endif
+  #if QORIQ_UART_BRIDGE_1_ENABLE
+    static uart_bridge_slave_context bridge_1_context = {
+      .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART Bridge 1"),
+      .type = INTERCOM_TYPE_UART_1,
+      .transmit_fifo = RTEMS_CHAIN_INITIALIZER_EMPTY(
+        bridge_1_context.transmit_fifo
+      )
+    };
+    #define BRIDGE_1_CONTEXT &bridge_1_context
+  #endif
+#endif
+
+const console_device console_device_table[] = {
   #if QORIQ_UART_0_ENABLE
     {
-      .sDeviceName = "/dev/ttyS0",
-      .deviceType = SERIAL_NS16550,
-      .pDeviceFns = DEVICE_FNS,
-      .deviceProbe = NULL,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) BSP_CONSOLE_BAUD,
-      .ulCtrlPort1 = (uintptr_t) &qoriq.uart_0,
-      .ulCtrlPort2 = 0,
-      .ulDataPort =  (uintptr_t) &qoriq.uart_0,
-      .getRegister = get_register,
-      .setRegister = set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 0,
-      .ulIntVector = QORIQ_IRQ_DUART
+      .device_file = "/dev/ttyS0",
+      .probe = ns16550_probe,
+      .handler = DEVICE_FNS,
+      .context = &qoriq_uart_context_0.base
     },
   #endif
   #if QORIQ_UART_1_ENABLE
     {
-      .sDeviceName = "/dev/ttyS1",
-      .deviceType = SERIAL_NS16550,
-      .pDeviceFns = DEVICE_FNS,
-      .deviceProbe = NULL,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) BSP_CONSOLE_BAUD,
-      .ulCtrlPort1 = (uintptr_t) &qoriq.uart_1,
-      .ulCtrlPort2 = 0,
-      .ulDataPort =  (uintptr_t) &qoriq.uart_1,
-      .getRegister = get_register,
-      .setRegister = set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 0,
-      .ulIntVector = QORIQ_IRQ_DUART
+      .device_file = "/dev/ttyS1",
+      .probe = ns16550_probe,
+      .handler = DEVICE_FNS,
+      .context = &qoriq_uart_context_1.base
     },
   #endif
@@ -163,11 +155,11 @@
     {
       #if QORIQ_UART_1_ENABLE
-        .sDeviceName = "/dev/ttyB0",
+        .device_file = "/dev/ttyB0",
       #else
-        .sDeviceName = "/dev/ttyS0",
+        .device_file = "/dev/ttyS0",
       #endif
-      .deviceType = SERIAL_CUSTOM,
-      .pDeviceFns = BRIDGE_FNS,
-      .pDeviceParams = BRIDGE_0_CONTROL
+      .probe = BRIDGE_PROBE,
+      .handler = BRIDGE_FNS,
+      .context = BRIDGE_0_CONTEXT
     },
   #endif
@@ -175,29 +167,26 @@
     {
       #if QORIQ_UART_1_ENABLE
-        .sDeviceName = "/dev/ttyB1",
+        .device_file = "/dev/ttyB1",
       #else
-        .sDeviceName = "/dev/ttyS1",
+        .device_file = "/dev/ttyS1",
       #endif
-      .deviceType = SERIAL_CUSTOM,
-      .pDeviceFns = BRIDGE_FNS,
-      .pDeviceParams = BRIDGE_1_CONTROL
+      .probe = BRIDGE_PROBE,
+      .handler = BRIDGE_FNS,
+      .context = BRIDGE_1_CONTEXT
     }
   #endif
 };
 
+const size_t console_device_count = RTEMS_ARRAY_SIZE(console_device_table);
+
 static void output_char(char c)
 {
-  int minor = (int) Console_Port_Minor;
-  const console_tbl **ct_tbl = Console_Port_Tbl;
+  rtems_termios_device_context *ctx = console_device_table[0].context;
 
-  if (ct_tbl != NULL) {
-    const console_fns *cf = ct_tbl[minor]->pDeviceFns;
+  if (c == '\n') {
+    ns16550_polled_putchar(ctx, '\r');
+  }
 
-    if (c == '\n') {
-      (*cf->deviceWritePolled)(minor, '\r');
-    }
-
-    (*cf->deviceWritePolled)(minor, c);
-  }
+  ns16550_polled_putchar(ctx, c);
 }
 
Index: c/src/lib/libbsp/powerpc/qoriq/console/uart-bridge-master.c
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/console/uart-bridge-master.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/qoriq/console/uart-bridge-master.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2011 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2011-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -26,6 +26,4 @@
 #include <unistd.h>
 #include <termios.h>
-
-#include <libchip/sersupp.h>
 
 #include <bspopts.h>
@@ -56,10 +54,10 @@
 {
   rtems_status_code sc = RTEMS_SUCCESSFUL;
-  uart_bridge_master_control *control = arg;
+  uart_bridge_master_context *ctx = arg;
 
   sc = rtems_chain_append_with_notification(
-    &control->transmit_fifo,
+    &ctx->transmit_fifo,
     &packet->glue.node,
-    control->transmit_task,
+    ctx->transmit_task,
     TRANSMIT_EVENT
   );
@@ -69,8 +67,8 @@
 static void receive_task(rtems_task_argument arg)
 {
-  uart_bridge_master_control *control = (uart_bridge_master_control *) arg;
-  intercom_type type = control->type;
+  uart_bridge_master_context *ctx = (uart_bridge_master_context *) arg;
+  intercom_type type = ctx->type;
 
-  int fd = open(control->device_path, O_RDONLY);
+  int fd = open(ctx->device_path, O_RDONLY);
   assert(fd >= 0);
 
@@ -95,8 +93,8 @@
 {
   rtems_status_code sc = RTEMS_SUCCESSFUL;
-  uart_bridge_master_control *control = (uart_bridge_master_control *) arg;
-  rtems_chain_control *fifo = &control->transmit_fifo;
+  uart_bridge_master_context *ctx = (uart_bridge_master_context *) arg;
+  rtems_chain_control *fifo = &ctx->transmit_fifo;
 
-  int fd = open(control->device_path, O_WRONLY);
+  int fd = open(ctx->device_path, O_WRONLY);
   assert(fd >= 0);
 
@@ -120,10 +118,10 @@
   char name,
   rtems_task_entry entry,
-  uart_bridge_master_control *control
+  uart_bridge_master_context *ctx
 )
 {
   rtems_status_code sc = RTEMS_SUCCESSFUL;
   rtems_id task = RTEMS_ID_NONE;
-  char index = (char) ('0' + control->type - INTERCOM_TYPE_UART_0);
+  char index = (char) ('0' + ctx->type - INTERCOM_TYPE_UART_0);
 
   sc = rtems_task_create(
@@ -140,5 +138,5 @@
     task,
     entry,
-    (rtems_task_argument) control
+    (rtems_task_argument) ctx
   );
   assert(sc == RTEMS_SUCCESSFUL);
@@ -147,49 +145,37 @@
 }
 
-static void initialize(int minor)
+bool qoriq_uart_bridge_master_probe(rtems_termios_device_context *base)
 {
-  console_tbl *ct = Console_Port_Tbl [minor];
-  uart_bridge_master_control *control = ct->pDeviceParams;
-  intercom_type type = control->type;
+  uart_bridge_master_context *ctx = (uart_bridge_master_context *) base;
+  intercom_type type = ctx->type;
 
-  qoriq_intercom_service_install(type, uart_bridge_master_service, control);
-  create_task('R', receive_task, control);
-  control->transmit_task = create_task('T', transmit_task, control);
+  qoriq_intercom_service_install(type, uart_bridge_master_service, ctx);
+  create_task('R', receive_task, ctx);
+  ctx->transmit_task = create_task('T', transmit_task, ctx);
+
+  return true;
 }
 
-static int first_open(int major, int minor, void *arg)
+static bool first_open(
+  struct rtems_termios_tty *tty,
+  rtems_termios_device_context *base,
+  struct termios *term,
+  rtems_libio_open_close_args_t *args
+)
 {
-  return -1;
+  return false;
 }
 
-static int last_close(int major, int minor, void *arg)
+static bool set_attributes(
+  rtems_termios_device_context *base,
+  const struct termios *term
+)
 {
-  return -1;
+  return false;
 }
 
-static int read_polled(int minor)
-{
-  return -1;
-}
-
-static void write_polled(int minor, char c)
-{
-  /* Do nothing */
-}
-
-static int set_attributes(int minor, const struct termios *term)
-{
-  return -1;
-}
-
-const console_fns qoriq_uart_bridge_master = {
-  .deviceProbe = libchip_serial_default_probe,
-  .deviceFirstOpen = first_open,
-  .deviceLastClose = last_close,
-  .deviceRead = read_polled,
-  .deviceWrite = NULL,
-  .deviceInitialize = initialize,
-  .deviceWritePolled = write_polled,
-  .deviceSetAttributes = set_attributes,
-  .deviceOutputUsesInterrupts = false
+const rtems_termios_device_handler qoriq_uart_bridge_master = {
+  .first_open = first_open,
+  .set_attributes = set_attributes,
+  .mode = TERMIOS_POLLED
 };
Index: c/src/lib/libbsp/powerpc/qoriq/console/uart-bridge-slave.c
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/console/uart-bridge-slave.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/qoriq/console/uart-bridge-slave.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -51,6 +51,6 @@
 static void uart_bridge_slave_service(intercom_packet *packet, void *arg)
 {
-  uart_bridge_slave_control *control = arg;
-  struct rtems_termios_tty *tty = control->tty;
+  uart_bridge_slave_context *ctx = arg;
+  struct rtems_termios_tty *tty = ctx->tty;
 
   /* Workaround for https://www.rtems.org/bugzilla/show_bug.cgi?id=1736 */
@@ -66,7 +66,7 @@
 {
   rtems_status_code sc = RTEMS_SUCCESSFUL;
-  uart_bridge_slave_control *control = (uart_bridge_slave_control *) arg;
-  rtems_chain_control *fifo = &control->transmit_fifo;
-  struct rtems_termios_tty *tty = control->tty;
+  uart_bridge_slave_context *ctx = (uart_bridge_slave_context *) arg;
+  rtems_chain_control *fifo = &ctx->transmit_fifo;
+  struct rtems_termios_tty *tty = ctx->tty;
 
   while (true) {
@@ -92,10 +92,10 @@
 
 static void create_transmit_task(
-  uart_bridge_slave_control *control
+  uart_bridge_slave_context *ctx
 )
 {
   rtems_status_code sc = RTEMS_SUCCESSFUL;
   rtems_id task = RTEMS_ID_NONE;
-  char index = (char) ('0' + control->type - INTERCOM_TYPE_UART_0);
+  char index = (char) ('0' + ctx->type - INTERCOM_TYPE_UART_0);
 
   sc = rtems_task_create(
@@ -112,52 +112,51 @@
     task,
     transmit_task,
-    (rtems_task_argument) control
+    (rtems_task_argument) ctx
   );
   assert(sc == RTEMS_SUCCESSFUL);
 
-  control->transmit_task = task;
+  ctx->transmit_task = task;
 }
 
-static void initialize(int minor)
+static bool first_open(
+  struct rtems_termios_tty *tty,
+  rtems_termios_device_context *base,
+  struct termios *term,
+  rtems_libio_open_close_args_t *args
+)
 {
-  /* Do nothing */
+  uart_bridge_slave_context *ctx = (uart_bridge_slave_context *) base;
+  intercom_type type = ctx->type;
+
+  ctx->tty = tty;
+  rtems_termios_set_initial_baud(tty, 115200);
+  create_transmit_task(ctx);
+  qoriq_intercom_service_install(type, uart_bridge_slave_service, ctx);
+
+  return true;
 }
 
-static int first_open(int major, int minor, void *arg)
+static void last_close(
+  struct rtems_termios_tty *tty,
+  rtems_termios_device_context *base,
+  rtems_libio_open_close_args_t *args
+)
 {
-  rtems_libio_open_close_args_t *oc = (rtems_libio_open_close_args_t *) arg;
-  struct rtems_termios_tty *tty = (struct rtems_termios_tty *) oc->iop->data1;
-  console_tbl *ct = Console_Port_Tbl[minor];
-  console_data *cd = &Console_Port_Data [minor];
-  uart_bridge_slave_control *control = ct->pDeviceParams;
-  intercom_type type = control->type;
+  uart_bridge_slave_context *ctx = (uart_bridge_slave_context *) base;
 
-  control->tty = tty;
-  cd->termios_data = tty;
-  rtems_termios_set_initial_baud(tty, 115200);
-  create_transmit_task(control);
-  qoriq_intercom_service_install(type, uart_bridge_slave_service, control);
-
-  return 0;
+  qoriq_intercom_service_remove(ctx->type);
 }
 
-static int last_close(int major, int minor, void *arg)
-{
-  console_tbl *ct = Console_Port_Tbl[minor];
-  uart_bridge_slave_control *control = ct->pDeviceParams;
-
-  qoriq_intercom_service_remove(control->type);
-
-  return 0;
-}
-
-static ssize_t write_with_interrupts(int minor, const char *buf, size_t len)
+static void write_with_interrupts(
+  rtems_termios_device_context *base,
+  const char *buf,
+  size_t len
+)
 {
   if (len > 0) {
     rtems_status_code sc = RTEMS_SUCCESSFUL;
-    console_tbl *ct = Console_Port_Tbl[minor];
-    uart_bridge_slave_control *control = ct->pDeviceParams;
+    uart_bridge_slave_context *ctx = (uart_bridge_slave_context *) base;
     intercom_packet *packet = qoriq_intercom_allocate_packet(
-      control->type,
+      ctx->type,
       INTERCOM_SIZE_64
     );
@@ -171,43 +170,26 @@
      */
     sc = rtems_chain_append_with_notification(
-      &control->transmit_fifo,
+      &ctx->transmit_fifo,
       &packet->glue.node,
-      control->transmit_task,
+      ctx->transmit_task,
       TRANSMIT_EVENT
     );
     assert(sc == RTEMS_SUCCESSFUL);
   }
-
-  return 0;
 }
 
-static void write_polled(int minor, char c)
+static bool set_attributes(
+  rtems_termios_device_context *base,
+  const struct termios *term
+)
 {
-  console_tbl *ct = Console_Port_Tbl[minor];
-  uart_bridge_slave_control *control = ct->pDeviceParams;
-  intercom_packet *packet = qoriq_intercom_allocate_packet(
-    control->type,
-    INTERCOM_SIZE_64
-  );
-  char *data = packet->data;
-  data [0] = c;
-  packet->size = 1;
-  qoriq_intercom_send_packet(QORIQ_UART_BRIDGE_MASTER_CORE, packet);
+  return false;
 }
 
-static int set_attribues(int minor, const struct termios *term)
-{
-  return -1;
-}
-
-const console_fns qoriq_uart_bridge_slave = {
-  .deviceProbe = libchip_serial_default_probe,
-  .deviceFirstOpen = first_open,
-  .deviceLastClose = last_close,
-  .deviceRead = NULL,
-  .deviceWrite = write_with_interrupts,
-  .deviceInitialize = initialize,
-  .deviceWritePolled = write_polled,
-  .deviceSetAttributes = set_attribues,
-  .deviceOutputUsesInterrupts = true
+const rtems_termios_device_handler qoriq_uart_bridge_slave = {
+  .first_open = first_open,
+  .last_close = last_close,
+  .write = write_with_interrupts,
+  .set_attributes = set_attributes,
+  .mode = TERMIOS_IRQ_DRIVEN
 };
Index: c/src/lib/libbsp/powerpc/qoriq/include/uart-bridge.h
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/include/uart-bridge.h	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/qoriq/include/uart-bridge.h	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2011 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2011-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -24,5 +24,5 @@
 #define LIBBSP_POWERPC_QORIQ_UART_BRIDGE_H
 
-#include <libchip/serial.h>
+#include <rtems/termiostypes.h>
 
 #include <bsp/intercom.h>
@@ -43,20 +43,24 @@
 
 typedef struct {
+  rtems_termios_device_context base;
   const char *device_path;
   intercom_type type;
   rtems_id transmit_task;
   rtems_chain_control transmit_fifo;
-} uart_bridge_master_control;
+} uart_bridge_master_context;
 
 typedef struct {
+  rtems_termios_device_context base;
   struct rtems_termios_tty *tty;
   intercom_type type;
   rtems_id transmit_task;
   rtems_chain_control transmit_fifo;
-} uart_bridge_slave_control;
+} uart_bridge_slave_context;
 
-extern const console_fns qoriq_uart_bridge_master;
+bool qoriq_uart_bridge_master_probe(rtems_termios_device_context *base);
 
-extern const console_fns qoriq_uart_bridge_slave;
+extern const rtems_termios_device_handler qoriq_uart_bridge_master;
+
+extern const rtems_termios_device_handler qoriq_uart_bridge_slave;
 
 /** @} */
Index: c/src/lib/libbsp/powerpc/qoriq/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/startup/bspstart.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/qoriq/startup/bspstart.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -25,5 +25,5 @@
 #include <rtems/counter.h>
 
-#include <libchip/serial.h>
+#include <libchip/ns16550.h>
 
 #include <libcpu/powerpc-utility.h>
@@ -37,4 +37,5 @@
 #include <bsp/mmu.h>
 #include <bsp/qoriq.h>
+#include <bsp/console-termios.h>
 
 LINKER_SYMBOL(bsp_exc_vector_base);
@@ -51,4 +52,5 @@
 
   rtems_interrupt_disable(level);
+  (void) level;
 
   printk("%s PANIC %s\n", rtems_get_version_string(), s);
@@ -64,4 +66,5 @@
 
   rtems_interrupt_disable(level);
+  (void) level;
 
   printk("%s PANIC ERROR %u\n", rtems_get_version_string(), n);
@@ -76,13 +79,10 @@
   unsigned long i = 0;
 
-  ppc_cpu_id_t myCpu;
-  ppc_cpu_revision_t myCpuRevision;
-
   /*
    * Get CPU identification dynamically. Note that the get_ppc_cpu_type() function
    * store the result in global variables so that it can be used latter...
    */
-  myCpu = get_ppc_cpu_type();
-  myCpuRevision = get_ppc_cpu_revision();
+  get_ppc_cpu_type();
+  get_ppc_cpu_revision();
 
   /* Initialize some device driver parameters */
@@ -94,14 +94,22 @@
 
   /* Initialize some console parameters */
-  for (i = 0; i < Console_Configuration_Count; ++i) {
-    console_tbl *ct = &Console_Configuration_Ports[i];
+  for (i = 0; i < console_device_count; ++i) {
+    const console_device *dev = &console_device_table[i];
+    const rtems_termios_device_handler *ns16550 =
+      #ifdef BSP_USE_UART_INTERRUPTS
+        &ns16550_handler_interrupt;
+      #else
+        &ns16550_handler_polled;
+      #endif
 
-    ct->ulClock = BSP_bus_frequency;
+    if (dev->handler == ns16550) {
+      ns16550_context *ctx = (ns16550_context *) dev->context;
 
-    #ifdef HAS_UBOOT
-      if (ct->deviceType == SERIAL_NS16550) {
-        ct->pDeviceParams = (void *) bsp_uboot_board_info.bi_baudrate;
-      }
-    #endif
+      ctx->clock = BSP_bus_frequency;
+
+      #ifdef HAS_UBOOT
+        ctx->initial_baud = bsp_uboot_board_info.bi_baudrate;
+      #endif
+    }
   }
 
Index: c/src/libchip/Makefile.am
===================================================================
--- c/src/libchip/Makefile.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/libchip/Makefile.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -111,4 +111,5 @@
     serial/z85c30_reg.c serial/serprobe.c serial/mc68681_p.h \
     serial/z85c30_p.h
+libserialio_a_SOURCES += serial/ns16550-context.c
 
 EXTRA_DIST += serial/README.mc68681 serial/README.ns16550 \
